c square root of raised cosine impulse response
C PROGRAM  SQRTRACO.FOR
C
	DIMENSION XX(-512:512)
	CHARACTER*70 FILE1
	DOUBLE PRECISION T,XX,TB,PI,HRESP,REF
	PARAMETER(PI=3.141592653589)
C
C       A  = EXCESS BANDWIDTH FACTOR
C       TB = BAUD PERIOD
C       T  = TIME/TB
C       NPBAUD = NUMBER OF SAMPLES PER BAUD
C       NMAX = NPBAUD * (MAXIMUM NUMBER OF BAUD BEFORE TRUNCATION OF
C               IMPULSE RESPONSE)
C       NTAP = NUMBER OF FILTER TAPS
C       H(T) = IMPULSE RESPONSE OF SQUARE ROOT OF RAISED COSINE FILTER
C
      H(T)=4.*A/(PI*SQRT(TB))*(COS(PI*T+PI/4.)*SIN((4.*A*T+1.)*PI/4.)/
     1  (4.*A*T+1) + COS(PI*T-PI/4.)*SIN((4.*A*T-1)*PI/4.)/(4.*A*T-1.))
     2 +(1./SQRT(TB))*SIN((1.-A)*PI*T)/(PI*T)

	WRITE(*,'(A\)') ' ENTER NAME FOR  [t, g(t)] LIST FILE: '
	READ(*,'(A70)') FILE1
	OPEN(10, FILE=FILE1)
	WRITE(*,'(A\)')' ENTER FILENAME FOR g(t) SORTED AS SUBFILTERS: '
	READ(*,'(A70)') FILE1
	OPEN(8, FILE=FILE1)
	WRITE(*,'(A\)')' ENTER FILENAME FOR FREQUENCY RESPONSE: '
	READ(*,'(A70)') FILE1
	OPEN(11, FILE=FILE1)
	WRITE(*,'(A\)') ' ENTER SYMBOL RATE, FS: '
	READ(*,*) FS
	TB = 1./FS
999     WRITE(*,'(A\)') ' ENTER NUMBER OF SAMPLES/BAUD, M: '
	READ(*,*) NPBAUD
	WRITE(*,'(A\)') ' ENTER TRUNCATION LIMIT, L (+/- L BAUDS): '
	READ(*,*) L
	WRITE(*,'(A\)') ' ENTER EXCESS BANDWIDTH FACTOR, ALPHA: '
	READ(*,*) A
	NMAX = NPBAUD*L
	IF(NMAX.GT.512) THEN
	   WRITE(*,*) ' M*L MUST BE LESS THAN OR EQUAL TO 512.'
	   GOTO 999
	ENDIF
	NTAP=2*NMAX+1
	DO 2 I=-512,512
2       XX(I)=0.
	DO 1 I=-NMAX,NMAX
	T=FLOAT(I)/NPBAUD
	IF (T.EQ.0.) THEN
	  X=(1.-A)/SQRT(TB)+4.*A/(PI*SQRT(TB))
	  XX(0)=X
	ELSE IF(ABS((ABS(4.*A*T)-1.)).LE.1.E-9) THEN
	  XX(I)=SIN((1.-A)*PI*T)/(SQRT(TB)*PI*T)+(4.*A/(PI*SQRT(TB)))*
     1     (COS(PI*ABS(T)-PI/4.)*PI/4. + COS(PI*ABS(T)+PI/4.)*
     2      SIN(PI*(4.*A*ABS(T)+1.)/4.)/(4.*A*ABS(T)+1.))
	ELSE
	  X=H(T)
	  XX(I)=X
	ENDIF
C
C  HAMMING WINDOW and also scale by SQRT(TB) to get about the same
C    transmitted power level as for the raised cosine shaping
C
	XX(I)=XX(I)*(0.54+0.46*COS(2.*PI*I/NTAP))*SQRT(TB)
C
1       WRITE(10,*) T,XX(I)

C  SORT IMPULSE RESPONSE AND WRITE OUT FILE CONTAINING SUBFILTER
C  LISTINGS IN FORM THAT CAN BE DIRECTLY USED IN C PROGRAM
C
       WRITE(8,*) '/*  In g[i][j], i is subfilter index, j is coefficien
     +t index in subfilter */'
       DO 20 I=0,NPBAUD-1
         WRITE(8,*) ' '
       DO 21 K=-NMAX+I,NMAX-1,NPBAUD
  21       WRITE(8,23) I, (K+NMAX-I)/NPBAUD, XX(K)
  23       FORMAT('      g[',I3,'][',I3,'] = ', E15.6,';')
20     CONTINUE

	F=0.
	FREQMAX= (1.+ A)*FS/2.
	DF = NPBAUD*FS/(NTAP*10.)
	DO 3 F = 0,FS*NPBAUD/2.,DF
	HRESP=0.
	DO 4 K=1,NMAX
4       HRESP=HRESP+XX(K)*COS(2.*PI*F*K*TB/FLOAT(NPBAUD))
	HRESP=HRESP*2. + XX(0)
	HRESP=20*LOG10(ABS(HRESP))
	IF(F.EQ.0) REF=HRESP
	HRESP=HRESP-REF
	WRITE(11,*) F,HRESP
3       CONTINUE
	END
